program allocarray2
    implicit none
    integer :: i, n
    integer, dimension(:), allocatable :: a
    character(len=30) :: arg

    if (command_argument_count() < 1) then
        print *,'Use: allocatable N, '//&
                ' where N is array size.'
        stop
    endif

    call get_command_argument(1, arg)
    read( arg,'(I30)'), n
     
    print *,'Allocating array of size ', n
    allocate(a(n))

    a = [(i,i=1,n)]
    print *, a
    
    deallocate(a)
end program allocarray2


