program matvec
    implicit none
    integer, dimension(4,5) :: a
    integer, dimension(5,4) :: at
    integer, dimension(4,4) :: aat
    integer :: i

    a = reshape([(i,i=1,4*5)],[4,5])
    at = transpose(a)
    print *,'A = '
    call printmat(a)
    print *,'A^T = '
    call printmat(at)

    aat = matmul(a,at)
    print *,'A . A^T = '
    call printmat(aat)

    print *,'A . A^T subarray = '
    call printmat(aat(2:4,1:3))
contains
    subroutine printmat(a)
    implicit none
    integer, dimension(:,:) :: a
    integer :: nr, nc, i, j

    nr = size(a,1)
    nc = size(a,2)
    do i=1,nr
        print '(99(I4,1X))', (a(i,j), j=1,nc)
    enddo
    end subroutine printmat
end program matvec
