program interface
    use integrate
    use functions
    implicit none

    real, parameter :: pi = 4.*atan(1.)
    real :: approx
    real :: exact = pi/2.

    approx = integratefx(0., pi, sinesquared, 1.e-6)
    print *, 'Approximate integral = ', approx
    print *, 'Exact integral = ', exact
end program interface
