program realkinds
    use iso_fortran_env
    implicit none
    
    real :: x
    real(kind=real32) :: x32
    real(kind=real64) :: x64
    real(kind=real128):: x128

    real(kind=selected_real_kind(6)) :: y6
    real(kind=selected_real_kind(15)):: y15

    print *,'Default:'
    print *, precision(x), range(x)
    print *,'Real32:'
    print *, precision(x32), range(x32)
    print *,'Real64:'
    print *, precision(x64), range(x64)
    print *,'Real128:'
    print *, precision(x128), range(x128)
    
    print *,''

    print *,'Selected Real Kind 6:'
    print *, precision(y6), range(y6)
    
    print *,'Selected Real Kind 15:'
    print *, precision(y15), range(y15)
    
end program realkinds



